part of '../flutterx_live_data.dart';

abstract class Dispatcher {
  static const Dispatcher postFrame = _PostFrameDispatcher._();

  final bool postFrameSafe;

  const Dispatcher({required this.postFrameSafe});

  void post(VoidCallback action);
}

class _PostFrameDispatcher extends Dispatcher {
  const _PostFrameDispatcher._() : super(postFrameSafe: true);

  @override
  void post(VoidCallback action) {
    final binding = WidgetsBinding.instance!;
    if (binding.schedulerPhase == SchedulerPhase.idle) return action();
    binding.addPostFrameCallback((_) => action());
  }
}
